#include "angband.h"
#include "cmd-spell.h"


/*!
* @brief gv̈斂@̊es
* @param spell @ID
* @param mode e (SPELL_NAME / SPELL_DESC / SPELL_INFO / SPELL_CAST)
* @return SPELL_NAME / SPELL_DESC / SPELL_INFO ɂ͕|C^ԂBSPELL_CASTNULLԂB
*/
cptr do_trump_spell(SPELL_IDX spell, BIT_FLAGS mode)
{
	bool name = (mode == SPELL_NAME) ? TRUE : FALSE;
	bool desc = (mode == SPELL_DESC) ? TRUE : FALSE;
	bool info = (mode == SPELL_INFO) ? TRUE : FALSE;
	bool cast = (mode == SPELL_CAST) ? TRUE : FALSE;
	bool fail = (mode == SPELL_FAIL) ? TRUE : FALSE;
	static const char s_random[] = _("_", "random");

	int dir;
	int plev = p_ptr->lev;

	switch (spell)
	{
	case 0:
		if (name) return _("V[gEe|[g", "Phase Door");
		if (desc) return _("ߋ̃e|[gB", "Teleport short distance.");

		{
			POSITION range = 10;

			if (info) return info_range(range);

			if (cast)
			{
				teleport_player(range, 0L);
			}
		}
		break;

	case 1:
		if (name) return _("w偂̃J[h", "Trump Spiders");
		if (desc) return _("w偂B", "Summons spiders.");

		{
			if (cast || fail)
			{
				msg_print(_("Ȃ͒w偂̃J[hɏW...", "You concentrate on the trump of an spider..."));
				if (trump_summoning(1, !fail, p_ptr->y, p_ptr->x, 0, SUMMON_SPIDER, PM_ALLOW_GROUP))
				{
					if (fail)
					{
						msg_print(_("ꂽw偂͓{ĂI", "The summoned spiders get angry!"));
					}
				}
			}
		}
		break;

	case 2:
		if (name) return _("Vbt", "Shuffle");
		if (desc) return _("J[h̐肢B", "Causes random effects.");

		{
			if (info) return s_random;

			if (cast)
			{
				cast_shuffle();
			}
		}
		break;

	case 3:
		if (name) return _("tAEZbg", "Reset Recall");
		if (desc) return _("Ő[KύXB", "Resets the 'deepest' level for recall spell.");

		{
			if (cast)
			{
				if (!reset_recall()) return NULL;
			}
		}
		break;

	case 4:
		if (name) return _("e|[g", "Teleport");
		if (desc) return _("̃e|[gB", "Teleport long distance.");

		{
			POSITION range = plev * 4;

			if (info) return info_range(range);

			if (cast)
			{
				teleport_player(range, 0L);
			}
		}
		break;

	case 5:
		if (name) return _("m̃J[h", "Trump Spying");
		if (desc) return _("莞ԁAepV[\͂𓾂B", "Gives telepathy for a while.");

		{
			int base = 25;
			int sides = 30;

			if (info) return info_duration(base, sides);

			if (cast)
			{
				set_tim_esp(randint1(sides) + base, FALSE);
			}
		}
		break;

	case 6:
		if (name) return _("e|[gEX^[", "Teleport Away");
		if (desc) return _("X^[e|[gr[BRƖB", "Teleports all monsters on the line away unless resisted.");

		{
			int power = plev;

			if (info) return info_power(power);

			if (cast)
			{
				if (!get_aim_dir(&dir)) return NULL;

				fire_beam(GF_AWAY_ALL, dir, power);
			}
		}
		break;

	case 7:
		if (name) return _("̃J[h", "Trump Animals");
		if (desc) return _("1̂̓B", "Summons an animal.");

		{
			if (cast || fail)
			{
				int type = (!fail ? SUMMON_ANIMAL_RANGER : SUMMON_ANIMAL);
				msg_print(_("Ȃ͓̃J[hɏW...", "You concentrate on the trump of an animal..."));
				if (trump_summoning(1, !fail, p_ptr->y, p_ptr->x, 0, type, 0L))
				{
					if (fail)
					{
						msg_print(_("ꂽ͓{ĂI", "The summoned animal gets angry!"));
					}
				}
			}
		}
		break;

	case 8:
		if (name) return _("ړ̃J[h", "Trump Reach");
		if (desc) return _("ACȇֈړB", "Pulls a distant item close to you.");

		{
			int weight = plev * 15;

			if (info) return info_weight(weight);

			if (cast)
			{
				if (!get_aim_dir(&dir)) return NULL;

				fetch(dir, weight, FALSE);
			}
		}
		break;

	case 9:
		if (name) return _("J~J[̃J[h", "Trump Kamikaze");
		if (desc) return _("̔郂X^[B", "Summons monsters which explode by itself.");

		{
			if (cast || fail)
			{
				int x, y;
				int type;

				if (cast)
				{
					if (!target_set(TARGET_KILL)) return NULL;
					x = target_col;
					y = target_row;
				}
				else
				{
					/* Summons near player when failed */
					x = p_ptr->x;
					y = p_ptr->y;
				}

				if (p_ptr->pclass == CLASS_BEASTMASTER)
					type = SUMMON_KAMIKAZE_LIVING;
				else
					type = SUMMON_KAMIKAZE;

				msg_print(_("Ȃ̓J~J[̃J[hɏW...", "You concentrate on several trumps at once..."));
				if (trump_summoning(2 + randint0(plev / 7), !fail, y, x, 0, type, 0L))
				{
					if (fail)
					{
						msg_print(_("ꂽX^[͓{ĂI", "The summoned creatures get angry!"));
					}
				}
			}
		}
		break;

	case 10:
		if (name) return _("쏢", "Phantasmal Servant");
		if (desc) return _("1̗̂HB", "Summons a ghost.");

		{
			/* Phantasmal Servant is not summoned as enemy when failed */
			if (cast)
			{
				int summon_lev = plev * 2 / 3 + randint1(plev / 2);

				if (trump_summoning(1, !fail, p_ptr->y, p_ptr->x, (summon_lev * 3 / 2), SUMMON_PHANTOM, 0L))
				{
					msg_print(_("pł܂AllH", "'Your wish, master?'"));
				}
			}
		}
		break;

	case 11:
		if (name) return _("Xs[hEX^[", "Haste Monster");
		if (desc) return _("X^[1̂B", "Hastes a monster.");

		{
			if (cast)
			{
				bool result;

				/* Temporary enable target_pet option */
				bool old_target_pet = target_pet;
				target_pet = TRUE;

				result = get_aim_dir(&dir);

				/* Restore target_pet option */
				target_pet = old_target_pet;

				if (!result) return NULL;

				speed_monster(dir, plev);
			}
		}
		break;

	case 12:
		if (name) return _("e|[gEx", "Teleport Level");
		if (desc) return _("uɏォ̊KɃe|[gB", "Teleport to up or down stairs in a moment.");

		{
			if (cast)
			{
				if (!get_check(_("{ɑ̊KɃe|[g܂H", "Are you sure? (Teleport Level)"))) return NULL;
				teleport_level(0);
			}
		}
		break;

	case 13:
		if (name) return _("̔", "Dimension Door");
		if (desc) return _("Z̎w肵ꏊɃe|[gB", "Teleport to given location.");

		{
			POSITION range = plev / 2 + 10;

			if (info) return info_range(range);

			if (cast)
			{
				msg_print(_("̔JBړInIŉB", "You open a dimensional gate. Choose a destination."));
				if (!dimension_door()) return NULL;
			}
		}
		break;

	case 14:
		if (name) return _("A҂̎", "Word of Recall");
		if (desc) return _("nɂƂ̓_W̍Ő[KցA_WɂƂ͒nւƈړB",
			"Recalls player from dungeon to town, or from town to the deepest level of dungeon.");

		{
			int base = 15;
			int sides = 20;

			if (info) return info_delay(base, sides);

			if (cast)
			{
				if (!word_of_recall()) return NULL;
			}
		}
		break;

	case 15:
		if (name) return _("Ǖ", "Banish");
		if (desc) return _("ȆSẴX^[e|[gBRƖB", "Teleports all monsters in sight away unless resisted.");

		{
			int power = plev * 4;

			if (info) return info_power(power);

			if (cast)
			{
				banish_monsters(power);
			}
		}
		break;

	case 16:
		if (name) return _("ʒũJ[h", "Swap Position");
		if (desc) return _("1̂̃X^[ƈʒuB", "Swap positions of you and a monster.");

		{
			if (cast)
			{
				bool result;

				/* HACK -- No range limit */
				project_length = -1;

				result = get_aim_dir(&dir);

				/* Restore range to default */
				project_length = 0;

				if (!result) return NULL;

				teleport_swap(dir);
			}
		}
		break;

	case 17:
		if (name) return _("Afbh̃J[h", "Trump Undead");
		if (desc) return _("1̂̃AfbhB", "Summons an undead monster.");

		{
			if (cast || fail)
			{
				msg_print(_("Ȃ̓Afbh̃J[hɏW...", "You concentrate on the trump of an undead creature..."));
				if (trump_summoning(1, !fail, p_ptr->y, p_ptr->x, 0, SUMMON_UNDEAD, 0L))
				{
					if (fail)
					{
						msg_print(_("ꂽAfbh͓{ĂI", "The summoned undead creature gets angry!"));
					}
				}
			}
		}
		break;

	case 18:
		if (name) return _("঒ނ̃J[h", "Trump Reptiles");
		if (desc) return _("1̂̃qhB", "Summons a hydra.");

		{
			if (cast || fail)
			{
				msg_print(_("Ȃ঒ނ̃J[hɏW...", "You concentrate on the trump of a reptile..."));
				if (trump_summoning(1, !fail, p_ptr->y, p_ptr->x, 0, SUMMON_HYDRA, 0L))
				{
					if (fail)
					{
						msg_print(_("ꂽ঒ނ͓{ĂI", "The summoned reptile gets angry!"));
					}
				}
			}
		}
		break;

	case 19:
		if (name) return _("X^[̃J[h", "Trump Monsters");
		if (desc) return _("̃X^[B", "Summons some monsters.");

		{
			if (cast || fail)
			{
				int type;
				msg_print(_("Ȃ̓X^[̃J[hɏW...", "You concentrate on several trumps at once..."));
				if (p_ptr->pclass == CLASS_BEASTMASTER)
					type = SUMMON_LIVING;
				else
					type = 0;

				if (trump_summoning((1 + (plev - 15) / 10), !fail, p_ptr->y, p_ptr->x, 0, type, 0L))
				{
					if (fail)
					{
						msg_print(_("ꂽX^[͓{ĂI", "The summoned creatures get angry!"));
					}
				}

			}
		}
		break;

	case 20:
		if (name) return _("nEh̃J[h", "Trump Hounds");
		if (desc) return _("1O[ṽnEhB", "Summons a group of hounds.");

		{
			if (cast || fail)
			{
				msg_print(_("Ȃ̓nEh̃J[hɏW...", "You concentrate on the trump of a hound..."));
				if (trump_summoning(1, !fail, p_ptr->y, p_ptr->x, 0, SUMMON_HOUND, PM_ALLOW_GROUP))
				{
					if (fail)
					{
						msg_print(_("ꂽnEh͓{ĂI", "The summoned hounds get angry!"));
					}
				}
			}
		}
		break;

	case 21:
		if (name) return _("gv̐n", "Trump Branding");
		if (desc) return _("Ƀgv̑B", "Makes current weapon a Trump weapon.");

		{
			if (cast)
			{
				brand_weapon(5);
			}
		}
		break;

	case 22:
		if (name) return _("lԃgv", "Living Trump");
		if (desc) return _("_Ƀe|[gˑRψقÄӎvŃe|[gˑRψقgɂB",
			"Gives mutation which makes you teleport randomly or makes you able to teleport at will.");

		{
			if (cast)
			{
				int mutation;

				if (one_in_(7))
					/* Teleport control */
					mutation = 12;
				else
					/* Random teleportation (uncontrolled) */
					mutation = 77;

				/* Gain the mutation */
				if (gain_random_mutation(mutation))
				{
					msg_print(_("Ȃ͐ĂJ[hɕςB", "You have turned into a Living Trump."));
				}
			}
		}
		break;

	case 23:
		if (name) return _("TCo[f[̃J[h", "Trump Cyberdemon");
		if (desc) return _("1̂̃TCo[f[B", "Summons a cyber demon.");

		{
			if (cast || fail)
			{
				msg_print(_("Ȃ̓TCo[f[̃J[hɏW...", "You concentrate on the trump of a Cyberdemon..."));
				if (trump_summoning(1, !fail, p_ptr->y, p_ptr->x, 0, SUMMON_CYBER, 0L))
				{
					if (fail)
					{
						msg_print(_("ꂽTCo[f[͓{ĂI", "The summoned Cyberdemon gets angry!"));
					}
				}
			}
		}
		break;

	case 24:
		if (name) return _("\̃J[h", "Trump Divination");
		if (desc) return _("߂̑SẴX^[A㩁AAKiAAăACemB",
			"Detects all monsters, traps, doors, stairs, treasures and items in your vicinity.");

		{
			int rad = DETECT_RAD_DEFAULT;

			if (info) return info_radius(rad);

			if (cast)
			{
				detect_all(rad);
			}
		}
		break;

	case 25:
		if (name) return _("m̃J[h", "Trump Lore");
		if (desc) return _("ACe̎\͂SɒmB", "*Identifies* an item.");

		{
			if (cast)
			{
				if (!identify_fully(FALSE)) return NULL;
			}
		}
		break;

	case 26:
		if (name) return _("񕜃X^[", "Heal Monster");
		if (desc) return _("X^[1̗̂̑͂񕜂B", "Heal a monster.");

		{
			int heal = plev * 10 + 200;

			if (info) return info_heal(0, 0, heal);

			if (cast)
			{
				bool result;

				/* Temporary enable target_pet option */
				bool old_target_pet = target_pet;
				target_pet = TRUE;

				result = get_aim_dir(&dir);

				/* Restore target_pet option */
				target_pet = old_target_pet;

				if (!result) return NULL;

				heal_monster(dir, heal);
			}
		}
		break;

	case 27:
		if (name) return _("hS̃J[h", "Trump Dragon");
		if (desc) return _("1̂̃hSB", "Summons a dragon.");

		{
			if (cast || fail)
			{
				msg_print(_("Ȃ̓hS̃J[hɏW...", "You concentrate on the trump of a dragon..."));
				if (trump_summoning(1, !fail, p_ptr->y, p_ptr->x, 0, SUMMON_DRAGON, 0L))
				{
					if (fail)
					{
						msg_print(_("ꂽhS͓{ĂI", "The summoned dragon gets angry!"));
					}
				}
			}
		}
		break;

	case 28:
		if (name) return _("覐΂̃J[h", "Trump Meteor");
		if (desc) return _("̎ӂ覐΂𗎂ƂB", "Makes meteor balls fall down to nearby random locations.");

		{
			HIT_POINT dam = plev * 2;
			int rad = 2;

			if (info) return info_multi_damage(dam);

			if (cast)
			{
				cast_meteor(dam, rad);
			}
		}
		break;

	case 29:
		if (name) return _("f[̃J[h", "Trump Demon");
		if (desc) return _("1̂̈B", "Summons a demon.");

		{
			if (cast || fail)
			{
				msg_print(_("Ȃ̓f[̃J[hɏW...", "You concentrate on the trump of a demon..."));
				if (trump_summoning(1, !fail, p_ptr->y, p_ptr->x, 0, SUMMON_DEMON, 0L))
				{
					if (fail)
					{
						msg_print(_("ꂽf[͓{ĂI", "The summoned demon gets angry!"));
					}
				}
			}
		}
		break;

	case 30:
		if (name) return _("ñJ[h", "Trump Greater Undead");
		if (desc) return _("1̂̏㋉AfbhB", "Summons a greater undead.");

		{
			if (cast || fail)
			{
				msg_print(_("Ȃ͋͂ȃAfbh̃J[hɏW...", "You concentrate on the trump of a greater undead being..."));
				/* May allow unique depend on level and dice roll */
				if (trump_summoning(1, !fail, p_ptr->y, p_ptr->x, 0, SUMMON_HI_UNDEAD, PM_ALLOW_UNIQUE))
				{
					if (fail)
					{
						msg_print(_("ꂽ㋉Afbh͓{ĂI", "The summoned greater undead creature gets angry!"));
					}
				}
			}
		}
		break;

	case 31:
		if (name) return _("ÑhS̃J[h", "Trump Ancient Dragon");
		if (desc) return _("1̂̌ÑhSB", "Summons an ancient dragon.");

		{
			if (cast)
			{
				int type;

				if (p_ptr->pclass == CLASS_BEASTMASTER)
					type = SUMMON_HI_DRAGON_LIVING;
				else
					type = SUMMON_HI_DRAGON;

				msg_print(_("Ȃ͌ÑhS̃J[hɏW...", "You concentrate on the trump of an ancient dragon..."));
				/* May allow unique depend on level and dice roll */
				if (trump_summoning(1, !fail, p_ptr->y, p_ptr->x, 0, type, PM_ALLOW_UNIQUE))
				{
					if (fail)
					{
						msg_print(_("ꂽÑhS͓{ĂI", "The summoned ancient dragon gets angry!"));
					}
				}
			}
		}
		break;
	}

	return "";
}
